/**
 * Titel:     Quelltext zu Kapitel 14 <br />
 * Buch:      Grundkurs-Java fr Wirtschaftsinformatiker. Vieweg 2007. <br />
 * Autoren:   Klaus-Georg Deck und Herbert Neuendorf
 * Copyright: Copyright (c) 2007 <br />
 * 
 * @author Herbert Neuendorf<br />
 * @version 1.0 <br />
 * 
 */
interface Konto {	
     void einzahlen( double betrag );  
	 void abheben( double betrag); 
}

class Girokonto implements Konto {
	private double dispo;
	private double saldo;
	private String name;
	public Girokonto( String n ) {
		name = n;    
		saldo = 0.0;    
		dispo = -1000.0;
	}
	public void einzahlen( double betrag ) {
		saldo = saldo + betrag;   
		IO.writeln( "Einzahlen Giro" ); 
	}
	public void abheben( double betrag ) {
		saldo = saldo - betrag;   
		IO.writeln( "Abheben Giro" ); 
	}
}

class Sparkonto implements Konto {
	private double zinsSatz;
	private double saldo;
	private String name;
	public Sparkonto( String n ) { 
		name = n;    
		zinsSatz = 0.03; 
	}
	public void einzahlen( double betrag ) {
		saldo = saldo + betrag;   
		IO.writeln( "Einzahlen Sparkonto" ); 
	}
	public void abheben( double betrag ) {
		saldo = saldo - betrag;   
		IO.writeln( "Abheben Sparkonto" ); 
	}
	public void setZinssatz( double zs ) { zinsSatz = zs; }
}
	
class Festzinskonto extends Sparkonto {
	private int laufzeit;
	private double saldo;
	private String name;
	public Festzinskonto( String n ) {
		super(n);      
		saldo = 0.0;     
		laufzeit = 3;
		setZinssatz( 0.05 );
	}	
	public void abheben( double betrag ) {
		saldo = saldo - betrag;   
		IO.writeln( "Abheben Festkonto" ); 
	}
	public void setLaufzeit( int lz ) { laufzeit = lz; }
}
 

public class Bank2 {
	public static void manipulation( Konto kn ) { 
		kn.abheben( 10.0); 
	}
	public static void main( String[] args ) {
		Girokonto g = new Girokonto( "Mueller" );
		Sparkonto s = new Sparkonto( "Huber" );
		Festzinskonto f = new Festzinskonto( "Schmidt" );
		manipulation( g );  
		manipulation( s );  
		manipulation( f );
	}
}







   
 









   


 
 





