/**
 * Titel:     Quelltext zu Kapitel 14 <br />
 * Buch:      Grundkurs-Java fr Wirtschaftsinformatiker. Vieweg 2007. <br />
 * Autoren:   Klaus-Georg Deck und Herbert Neuendorf
 * Copyright: Copyright (c) 2007 <br />
 * 
 * @author Herbert Neuendorf<br />
 * @version 1.0 <br />
 * 
 */

class Konto {	
	public String name;      
	public double saldo;
    public Konto( String n ) { 
		name = n;   
		saldo = 0.0; 
	}
    public void einzahlen( double betrag ) { 
		saldo = saldo + betrag;
	}
	public void abheben( double betrag) {
		saldo = saldo - betrag;    
		IO.writeln( "Abheben Konto" ); 
	}
}

class Giro extends Konto {
	private double dispo;      
	public Giro( String n ) {
		super(n);    
		saldo = 0.0;    
		dispo = -1000.0;
	}

	public void abheben( double betrag ) {
		saldo = saldo - betrag;   
		IO.writeln( "Abheben Giro" ); 
	}
}

class Sparkonto extends Konto {
	private double zinsSatz;    
	public Sparkonto( String n ) { 
		super(n);    
		zinsSatz = 0.03; 
	}
	public void abheben( double betrag ) {
		saldo = saldo - betrag;   
		IO.writeln( "Abheben Sparkonto" ); 
	}
	public void setZinssatz( double zs ) { zinsSatz = zs; }
}
	
class Festzinskonto extends Sparkonto {
	private int laufzeit;  
	public Festzinskonto( String n ) {
		super(n);      
		saldo = 0.0;     
		laufzeit = 3;
		setZinssatz( 0.05 );
	}	
	public void abheben( double betrag ) {
		saldo = saldo - betrag;   
		IO.writeln( "Abheben Festkonto" ); 
	}
	public void setLaufzeit( int lz ) { laufzeit = lz; }
}
 
public class InstanzTest {
	public static void main( String[] args ) {
		Konto k1, k2;       
		Sparkonto s1;
		Konto k = new Konto( "Meier" );        
		Sparkonto s = new Sparkonto( "Fischer" );
		k1 = k;      k2 = s;     // Upcast
		
		if( k1 instanceof Sparkonto ){    // liefert false
			s1 = (Sparkonto)k1;   // Downcast 
			s1.setZinssatz( 0.04 );
		} 
		
		if( k2 instanceof Sparkonto ){    // liefert true
			s1 = (Sparkonto)k2;   // Downcast
			s1.setZinssatz( 0.04 );
		} 
	}
} 
   
 









   


 
 





