/**
 * Titel:     Quelltext zu Kapitel 14 <br />
 * Buch:      Grundkurs-Java fr Wirtschaftsinformatiker. Vieweg 2007. <br />
 * Autoren:   Klaus-Georg Deck und Herbert Neuendorf
 * Copyright: Copyright (c) 2007 <br />
 * 
 * @author Herbert Neuendorf<br />
 * @version 1.0 <br />
 * 
 */

class Konto {	
	public String name;      
	public double saldo;
    public Konto( String n ) { 
		name = n;   
		saldo = 0.0; 
	}
    public void einzahlen( double betrag ) { 
		saldo = saldo + betrag;
	}
	public void abheben( double betrag) {
		saldo = saldo - betrag;    
		IO.writeln( "Abheben Konto" ); 
	}
}

class Giro extends Konto {
	private double dispo;      
	public Giro( String n ) {
		super(n);    
		saldo = 0.0;    
		dispo = -1000.0;
	}

	public void abheben( double betrag ) {
		saldo = saldo - betrag;   
		IO.writeln( "Abheben Giro" ); 
	}
}

class Sparkonto extends Konto {
	private double zinsSatz;    
	public Sparkonto( String n ) { 
		super(n);     
		zinsSatz = 0.03; 
	}
	public void abheben( double betrag ) {
		saldo = saldo - betrag;   
		IO.writeln( "Abheben Sparkonto" ); 
	}
	public void setZinssatz( double zs ) { zinsSatz = zs; }
}
	
class Festzinskonto extends Sparkonto {
	private int laufzeit;  
	public Festzinskonto( String n ) {
		super(n);     
		saldo = 0.0;     
		laufzeit = 3;
		setZinssatz( 0.05 );
	}	
	public void abheben( double betrag ) {
		saldo = saldo - betrag;   
		IO.writeln( "Abheben Festkonto" ); 
	}
	public void setLaufzeit( int lz ) { laufzeit = lz; }
}
 
public class TypTest {
	public static void main( String[] args ) {
	
		Konto k1, k2;   // Statischer Typ: Konto
		
		// Dynamischer Typ von k1 wird: Sparkonto        
		k1 = new Sparkonto( "Huber" );      // Upcast
		
		// Dynamischer Typ von k2 wird: Festzinskonto
		k2 = new Festzinskonto( "Fischer" );  // Upcast
		
		// Methodenaufrufe gem dynamischem Typ
		// Methode abheben() von Sparkonto wird aufgerufen:
		k1.abheben( 30.0 );
		
		// Methode abheben() von Festzinskonto wird aufgerufen:
		k2.abheben( 70.0 ); 
		
		// Fehler - widerspricht statischem Typ von k1, k2:
		//k1.setZinssatz( 0.02 );  // Compilerfehler!
		//k2.setLaufzeit( 10 );    // Compilerfehler!
	}
} 


   
 









   


 
 





