/**
 * Titel:     Quelltext zu Kapitel 14 <br />
 * Buch:      Grundkurs-Java fr Wirtschaftsinformatiker. Vieweg 2007. <br />
 * Autoren:   Klaus-Georg Deck und Herbert Neuendorf
 * Copyright: Copyright (c) 2007 <br />
 * 
 * @author Herbert Neuendorf<br />
 * @version 1.0 <br />
 * 
 */

interface IFEuro {
	double KURS_E = 0.91;    
	double inDollar( double euroBetrag );
}

interface IFDollar {
	double KURS_D = 1.1;     
	double inEuro( double dollarBetrag );
}

class EuroDollarRechner implements IFEuro, IFDollar {
	public double inDollar( double euroBetrag ) {
		return  euroBetrag * IFEuro.KURS_E; 	
	}
	public double inEuro( double dollarBetrag ) {
		return  dollarBetrag * IFDollar.KURS_D;	
	}	
}

public class Umrechner {
	public static void euro2dollar( IFEuro iE ) {
		double e = IO.promptAndReadDouble( "Eurobetrag = " );
		IO.writeln(  "In Dollar :  " + iE.inDollar( e )  );
	}
	public static void dollar2euro( IFDollar iD ) {
		double d = IO.promptAndReadDouble( "Dollarbetrag = " );		
		IO.writeln(  "In Euro : " + iD.inEuro( d )  );
	}
	public static void main( String[] args ) {
		EuroDollarRechner edR  = new EuroDollarRechner();	
		euro2dollar( edR );       
		dollar2euro( edR );	
	}
}





   
 









   


 
 





